//
// Created:     05.09.06
// Aurthor:    Iain Gilbert
//

#if defined _account_included
  #endinput
#endif

#define _account_included
#pragma library account
#include "gtobase"
#include "gtodudb"

new gPlayerEmail[MAX_PLAYERS][MAX_NAME];
new gPlayerPassword[MAX_PLAYERS][MAX_NAME];
new gPlayerCreationDate[MAX_PLAYERS];
new gIsPlayerRegistered[MAX_PLAYERS];


public AccountSave(playerid)
{
	if (!IsPlayerRegistered(playerid)) return 0;
	new playername[MAX_STRING];
	playername = oGetPlayerName(playerid);
	strcat(playername,".Account",sizeof(playername));
	if (!udb_Exists(playername))
	{
		#if DEBUGLEVEL > 1
			printf("player_account_save: fail: account doesnt exists: %s",oGetPlayerName(playerid));
		#endif
		SendClientMessage(playerid,COLOR_RED, "That account name doesnt exists.");
		return 0;
	}
	new dbstring[MAX_DBSTRING];
	dbstring = CreateDBAccountString(playerid,gPlayerPassword[playerid],gPlayerEmail[playerid],gPlayerCreationDate[playerid]);
	udb_Savefile(playername,dbstring);
	return 1;
}


public AccountLogin(playerid,password[])
{
	if (gIsPlayerRegistered[playerid])
	{
	    SendClientMessage(playerid,COLOR_RED, "You are already logged in.");
	    return false;
	}
	#if DEBUGLEVEL > 0
		printf("Account Login");
	#endif
	// #IF FLATFILE
	new filename[MAX_STRING];
	new dbpassword[MAX_NAME];
	new dbstring[MAX_DBSTRING];
	filename = oGetPlayerName(playerid);
	strcat(filename,".Account",sizeof(filename));
 	if (!udb_Exists(filename))
	{
		SendClientMessage(playerid,COLOR_RED, "That account name does not exist. Use /register [password] [email] to create an account.");
	 	return false;
	}
	filename = oGetPlayerName(playerid);
	strcat(filename,".Account",sizeof(filename));
	dbstring = udb_Loadfile(filename);
 	new idx;
 	strtok2(dbstring,idx,gDBSeperator); // player name from db
 	set(dbpassword,strtok2(dbstring,idx,gDBSeperator));
 	if (!equal(password, dbpassword,false))
	{
		#if DEBUGLEVEL > 0
			printf("player_login: failed: incorrect password ID:%d NAME:%s :",playerid,oGetPlayerName(playerid));
		#endif
 		SendClientMessage(playerid,COLOR_RED, "Incorrect Password.");
 		SendClientMessage(playerid,COLOR_RED, "You will be auto kicked for security.");
 		KickPlayer(playerid); // kick them
	 	return false;
 	}
 	set(gPlayerEmail[playerid],strtok2(dbstring,idx,gDBSeperator));
    set(gPlayerCreationDate[playerid],strtok2(dbstring,idx,gDBSeperator));
 	gPlayerPassword[playerid] = dbpassword;
 	gIsPlayerRegistered[playerid] = 1;
 	PlayerLoadStats(playerid);
 	SendClientMessage(playerid,COLOR_GREEN, "Player login successfull.");
 	#if DEBUGLEVEL > 0
		printf("player: %d:  %s: login successfull ",playerid,oGetPlayerName(playerid));
	#endif
 	return true;

}

public AccountCommandHandler(playerid,text[]) // process account commands
{
	if (!IsPlayerConnected(playerid)) return 0;
	new cmd[20];
	new idx;
	set(cmd,strtok(text, idx));

	//TODO: changepass
	
    if(strcomp(cmd, "/register", true) == 1)
	{
	    #if OUTPUTLEVEL > 0
			printf("%d, %: register_command",playerid,oGetPlayerName(playerid));
		#endif

	 	//if (strfind(oGetPlayerName(playerid),"_",false) != -1)
		//{
		//	SendClientMessage(playerid, COLOR_MISC, "ERROR: BAD CHARACTER PLAYERNAME. Please use only a-z,0-9.");

//			return 1;
//		}

	    new password[MAX_NAME];
	    new email[MAX_NAME];
	    set(password,encrypt(strtok(text, idx))); // encrypt our password strait away, we will use encrypted pass from now on
	    set(email,strtok(text, idx));
	    if (strfind(email,gDBSeperator,false) != -1)
		{
			#if OUTPUTLEVEL > 0
				printf("%s: register_account: fail: DB seperator found in email",oGetPlayerName(playerid));
			#endif
			SendClientMessage(playerid, COLOR_MISC, "ERROR: BAD CHARACTER IN EMAIL.");

			return 1;
		}

  		if(!strlen(password))
		{
			SendClientMessage(playerid, COLOR_MISC, "USAGE: /register [password] <email>");
			return 1;
		}
		if (gIsPlayerRegistered[playerid])
		{
			SendClientMessage(playerid,COLOR_RED, "You are already logged in.");
			return 1;
		}
		
		new filename[MAX_STRING];
		new dbstring[MAX_DBSTRING];
		filename = oGetPlayerName(playerid);
  		strcat(filename,".Account",sizeof(filename));
		if (udb_Exists(filename))
  		{
			SendClientMessage(playerid,COLOR_RED, "That account name already exists.");
			return 1;
		}
		else
		{
		
			dbstring = CreateDBAccountString(playerid,password,email,0);
			udb_Create(filename,dbstring);
			#if DEBUGLEVEL > 0
				printf("create_account: success %s",oGetPlayerName(playerid));
			#endif
			#if OUTPUTLEVEL > 0
				printf("create_account: success %d  %s",playerid,oGetPlayerName(playerid));
			#endif
		}
		filename = oGetPlayerName(playerid);
  		strcat(filename,".Status",sizeof(filename));
  		if (udb_Exists(filename))
		{
			SendClientMessage(playerid,COLOR_RED, "ERROR: Player status already exists.");
			return 1;
		}
		else
		{
			dbstring = CreateDBStatsString(playerid);
			udb_Create(filename,dbstring);
			#if DEBUGLEVEL > 0
				printf("create_player: success %s",filename);
			#endif
			#if OUTPUTLEVEL > 0
				printf("create_player: success %d  %s",playerid,oGetPlayerName(playerid));
			#endif
		}
		
		SendClientMessage(playerid,COLOR_GREEN, "Account created.");
		AccountLogin(playerid,password);
		return 1;
	}

	if(strcomp(cmd, "/login", true) == 1)
	{
	    new password[MAX_STRING];
	    set(password,encrypt(strtok(text, idx))); // encrypt our password strait away, we will use encrypted pass from now on
		if(!strlen(password))
		{
			SendClientMessage(playerid, COLOR_MISC, "USAGE: /login [password]");
			return 1;
		}

		AccountLogin(playerid,password);
		return 1;
	}

	if(strcomp(cmd, "/savechar", true) == 1)
	{

		if (IsPlayerRegistered(playerid))
		{
		    PlayerSave(playerid);
			AccountSave(playerid);
		}
		return 1;
	}
	return 0;
}

public CreateDBAccountString(playerid,password[], email[], createtime)
{
	new dbstring[MAX_DBSTRING];
	new ctime[MAX_NAME];
    if (createtime == 0) {createtime = Now();}
    valstr(ctime, createtime);

	strins(dbstring, oGetPlayerName(playerid), strlen(dbstring));
	strins(dbstring, gDBSeperator, strlen(dbstring));
	strins(dbstring, password, strlen(dbstring));
	strins(dbstring, gDBSeperator, strlen(dbstring));
	strins(dbstring, email, strlen(dbstring));
	strins(dbstring, gDBSeperator, strlen(dbstring));
	strins(dbstring, ctime, strlen(dbstring));
	strins(dbstring, gDBSeperator, strlen(dbstring));
	new tmp[MAX_STRING];
	valstr(tmp,Now());
	strins(dbstring, tmp, strlen(dbstring));
	return dbstring;
}

