//
// Created:     05.09.06
// Aurthor:    Iain Gilbert
//

#if defined _commandhandler_included
  #endinput
#endif

#define _commandhandler_included
#pragma library commandhandler
#include "gtobase"
#include "gtoutils"
#include "player"
#include "account"

public CommandHandler(playerid,text[]) // process player commands
{
	if (!IsPlayerConnected(playerid)) return 0;
	new cmd[20];
	new idx;
	set(cmd,strtok(text, idx));
	
	if(strcomp(cmd, "/sound", true) == 1)
	{
	    new soundid;
	    soundid = strval(strtok(text, idx));
	    if (soundid <= 0) return 1;
	    new Float:playerx,Float:playery,Float:playerz;
		GetPlayerPos(playerid,playerx,playery,playerz);
     	PlayerPlaySound(playerid,soundid,playerx,playery,playerz);
		return 1;
	}
	
	
	
	
	if(strcomp(cmd, "/help", true) == 1)
	{
		SendPlayerFormattedText(playerid,"SA:MP: Grand Theft Online gamemode",0,COLOR_GREY);
		SendPlayerFormattedText(playerid,"Type: /objective : to find out what to do in this gamemode.",0,COLOR_GREY);
		SendPlayerFormattedText(playerid,"Type: /register [password] <email>: to create an account.",0,COLOR_GREY);
		SendPlayerFormattedText(playerid,"Type: /login [password]: to login to your account.",0,COLOR_GREY);
		SendPlayerFormattedText(playerid,"Type: /level : to display level information.",0,COLOR_GREY);
		SendPlayerFormattedText(playerid,"Type: /status : to display character information.",0,COLOR_GREY);
		SendPlayerFormattedText(playerid,"Type: /givecash [playerid] [money-amount] : to send money to other players.",0,COLOR_GREY);
        SendPlayerFormattedText(playerid,"Type: /gang help : to see help on gangs.",0,COLOR_GREY);

		return 1;
	}

	if(strcomp(cmd, "/objective", true) == 1)
	{
		SendPlayerFormattedText(playerid,"This gamemode is open, there's no specific win / endgame conditions to meet.",0,COLOR_GREY);
		SendPlayerFormattedText(playerid,"In SA:MP:GTO, when you kill a player, you will receive experience points & steal the money they are carrying.",0,COLOR_GREY);
		SendPlayerFormattedText(playerid,"Increasing experience points increases your level, which effects your spawn weapons and health and cashflow.",0,COLOR_GREY);
		SendPlayerFormattedText(playerid,"Experience points can be gained by killing people, winning races, holding ground, and more.",0,COLOR_GREY);
		SendPlayerFormattedText(playerid,"Bank your money at 24/7's so you dont loose it all when you die.",0,COLOR_GREY);
		SendPlayerFormattedText(playerid,"Type /level to see level information.",0,COLOR_GREY);
		SendPlayerFormattedText(playerid,"Players can create gangs to team up against opposing gangs nad players.",0,COLOR_GREY);

		return 1;
	}

	if((strcomp(cmd, "/stats", true) == 1) || (strcomp(cmd, "/status", true) == 1) || (strcomp(cmd, "/stat", true) == 1))
	{
		new string[256];
  		SendClientMessage(playerid,COLOR_MISC, "Player Status");
		format(string, sizeof(string), "Level: %d ", Player[playerid][Level]);
		SendClientMessage(playerid,COLOR_MISC, string);
		format(string, sizeof(string), "XP: %d ", Player[playerid][XP]);
		SendClientMessage(playerid,COLOR_MISC, string);
		format(string, sizeof(string), "Money: %d ", Player[playerid][Money]);
		SendClientMessage(playerid,COLOR_MISC, string);
		format(string, sizeof(string), "Deaths: %d ", Player[playerid][Deaths]);
		SendClientMessage(playerid,COLOR_MISC, string);
		format(string, sizeof(string), "Kills: %d ", Player[playerid][Kills]);
		SendClientMessage(playerid,COLOR_MISC, string);
    	return 1;
	}
	
	if(strcomp(cmd, "/level", true) == 1)
	{
	    CheckPlayerLevel(playerid);
		new string[256];
  		SendClientMessage(playerid,COLOR_MISC, "Player Level Information");
		format(string, sizeof(string), "Current Level: %d ", Player[playerid][Level]);
		SendClientMessage(playerid,COLOR_XP_GOOD, string);
		format(string, sizeof(string), "Current XP: %d ", Player[playerid][XP]);
		SendClientMessage(playerid,COLOR_XP_GOOD, string);
		format(string, sizeof(string), "XP to level: %d ", GetXPToLevel(playerid, Player[playerid][Level] + 1));
		SendClientMessage(playerid,COLOR_XP_BAD, string);
    	return 1;
	}

	if(strcomp(cmd, "/version", true) == 1)
	{
	    new string[MAX_STRING];
		SendClientMessage(playerid, COLOR_MISC, "This server is running:");
		format(string, sizeof(string), "SA:MP Grand Theft Online %s", VERSION);
		SendClientMessage(playerid, COLOR_GREEN,string);
		SendClientMessage(playerid, COLOR_MISC, "Created by Iain Gilbert");
		return 1;
	}

	if(strcomp(cmd, "/givecash", true) == 1)
	{
		new string[256];
		new giveplayerid, moneys;
		new sendername[MAX_PLAYER_NAME];
		new playermoney;
		new giveplayer[MAX_PLAYER_NAME];
	    new tmp[256];
		tmp = strtok(text, idx);

		if(!strlen(tmp))
		{
			SendClientMessage(playerid, COLOR_MISC, "USAGE: /givecash [playerid] [amount]");
			return 1;
		}
		giveplayerid = strval(tmp);

		tmp = strtok(text, idx);
		if(!strlen(tmp))
		{
			SendClientMessage(playerid, COLOR_MISC, "USAGE: /givecash [playerid] [amount]");
			return 1;
		}
 		moneys = strval(tmp);

		if (IsPlayerConnected(giveplayerid))
		{
			GetPlayerName(giveplayerid, giveplayer, sizeof(giveplayer));
			GetPlayerName(playerid, sendername, sizeof(sendername));
			playermoney = oGetPlayerMoney(playerid);
			if (moneys > 0 && playermoney >= moneys)
			{
				oGivePlayerMoney(playerid, (0 - moneys),1);
				oGivePlayerMoney(giveplayerid, moneys,1);
				format(string, sizeof(string), "You have sent %s(player: %d), $%d.", giveplayer,giveplayerid, moneys);
				SendClientMessage(playerid, COLOR_MONEY_GOOD, string);
				format(string, sizeof(string), "You have recieved $%d from %s(player: %d).", moneys, sendername, playerid);
				SendClientMessage(giveplayerid, COLOR_MONEY_GOOD, string);
				printf("%s(playerid:%d) has transfered %d to %s(playerid:%d)",sendername, playerid, moneys, giveplayer, giveplayerid);
			}
			else
			{
				SendClientMessage(playerid, COLOR_MISC, "Invalid transaction amount.");
			}
		}
		else
		{
			format(string, sizeof(string), "%d is not an active player.", giveplayerid);
			SendClientMessage(playerid, COLOR_MISC, string);
		}
		return 1;
	}
	return 0;
}
