//
// Created:     05.09.06
// Aurthor:    Iain Gilbert
//

#if defined _player_included
  #endinput
#endif

#define _player_included
#pragma library player
#include "gtobase"
#include "gtoutils"
#include "dutils"
#include "gtodudb"
#include "account"

#define MAX_PLAYERS 100 

enum PlayerInfo {
	IsActive, 	// is player online
	Float:Health, 	// health
	Money,          // Money
	Bank,           // Money in bank
	Level,          // Level
	XP,             // XP
    Deaths,         // Deaths
    Kills,          // Kills
    CarKills        // cars killed

}

new gPlayerCurrentKills[MAX_PLAYERS];

new PlayerGangid[MAX_PLAYERS];
new PlayerGangName[MAX_PLAYERS][MAX_NAME];

new Player[MAX_PLAYERS][PlayerInfo];

new PlayerSpawn[MAX_PLAYERS][CoordInfo];
new gSpawnTime[MAX_PLAYERS];

enum Quest_Stats {
    Quest_Name[MAX_NAME]
}

new PlayerQuest[MAX_PLAYERS]; // holds id of quest player is currently doing
new gQuests[MAX_QUESTS][Quest_Stats]; // table of all registered quests
new gQuestCount;

new Float:PlayerCP[MAX_PLAYERS][CoordInfo];
new bool:PlayerCPActive[MAX_PLAYERS];

new gMoneyKick[MAX_PLAYERS];
new gHealthKick[MAX_PLAYERS];

new iSpawnSet[MAX_PLAYERS];


// spawn lists by SA:MP team
new Float:gRandomPlayerSpawns[23][CoordInfo] = {
{1958.3783,1343.1572,15.3746},
{2199.6531,1393.3678,10.8203},
{2483.5977,1222.0825,10.8203},
{2637.2712,1129.2743,11.1797},
{2000.0106,1521.1111,17.0625},
{2024.8190,1917.9425,12.3386},
{2261.9048,2035.9547,10.8203},
{2262.0986,2398.6572,10.8203},
{2244.2566,2523.7280,10.8203},
{2335.3228,2786.4478,10.8203},
{2150.0186,2734.2297,11.1763},
{2158.0811,2797.5488,10.8203},
{1969.8301,2722.8564,10.8203},
{1652.0555,2709.4072,10.8265},
{1564.0052,2756.9463,10.8203},
{1271.5452,2554.0227,10.8203},
{1441.5894,2567.9099,10.8203},
{1480.6473,2213.5718,11.0234},
{1400.5906,2225.6960,11.0234},
{1598.8419,2221.5676,11.0625},
{1318.7759,1251.3580,10.8203},
{1558.0731,1007.8292,10.8125},
{1705.2347,1025.6808,10.8203}
};


public SpawnTimer()
{
	for (new playerid=0;playerid<MAX_PLAYERS;playerid++)
	{
		if (IsPlayerConnected(playerid))
		{
		    gSpawnTime[playerid]++;
		}
	}
}
	
public player_ResetStats(playerid)
{

	// reset player stats
	gIsPlayerRegistered[playerid] = false;
	
	Player[playerid][Level] = 0;
	Player[playerid][XP] = 0;
	oSetPlayerMoney(playerid,0);
	Player[playerid][Kills] = 0;
	Player[playerid][Deaths] = 0;
	gKickList[playerid] = 0;
	ResetQuest(playerid);
	gSpawnTime[playerid] = 0;
	PlayerGangid[playerid] = 0;
	
}

public IsPlayerRegistered(playerid)
{
	if (playerid == INVALID_PLAYER_ID) return 0;
	if (Player[playerid][IsActive] == 0) return 0;
	if (!IsPlayerConnected(playerid)) return 0;
	if (gIsPlayerRegistered[playerid] == 0) return 0;
	return 1;
}

public player_Disconnect(playerid)
{
	Player[playerid][IsActive] = 0;
}

public player_Connect(playerid)
{
	Player[playerid][IsActive] = 1;
	player_ResetStats(playerid);
}
 

public PlayerDeath(playerid,killerid,reason)
{
	Player[playerid][Deaths]++;
	gPlayerCurrentKills[playerid] = 0;
	if (oGetPlayerHealth(killerid) > 100)
    {
        gKickList[killerid] = 1;
	}
	if ((Player[playerid][Money] - 100) > 0)
	{
		Player[playerid][Money] = Player[playerid][Money] - 100;
	}
	else
	{
		oSetPlayerMoney(playerid,0);
	}
	if ((Player[playerid][XP] - (Player[playerid][XP] / 25)) > 0)
	{
		GivePlayerXP(playerid, (0 - (Player[playerid][XP] / 20)),1);	// take death penalty xp
	}
	else
	{
		SetPlayerXP(playerid,0);
	}
	
    UpdatePlayerScore(playerid);
}

public PlayerKill(killerid, victimid, reason) // earn xp, kills++
{
    Player[killerid][Kills]++;
    
    if (PlayerGangid[killerid] != 0)
	{
	    if (GangKill(PlayerGangid[killerid],killerid,victimid,reason) == 1) return;
	}
	gPlayerCurrentKills[killerid]++;
	new earnedXP;
	earnedXP = ((1+Player[victimid][Level]) * 50);
	if (earnedXP > (1+Player[killerid][Level]) * 100)
	{
	    earnedXP = ((1+Player[killerid][Level]) * 100);
	}

	if ((Player[killerid][XP] + earnedXP) <= MAX_XP)
	{
		GivePlayerXP(killerid, earnedXP,1);
	}
	else
	{
	    SetPlayerXP(killerid, MAX_XP);
	}
	
	new stolencash;
	if (oGetPlayerMoney(victimid) > 1000)
	{
		stolencash = (oGetPlayerMoney(victimid) - (oGetPlayerMoney(victimid) / 10));
	}
	else
	{
		stolencash = oGetPlayerMoney(victimid);
	}
	
	oGivePlayerMoney(victimid,0-stolencash,1);
	oGivePlayerMoney(killerid,stolencash,1);
    UpdatePlayerScore(killerid);
   	UpdatePlayerScore(victimid);
    return;
}

public RegisterQuest(name[MAX_NAME])
{
    if (gQuestCount >= MAX_QUESTS) return 0;
	gQuestCount++;
	new questid = gQuestCount;
	set(gQuests[questid][Quest_Name],name);
	return questid;
}

public ResetQuest(playerid)
{
		oDisablePlayerCheckpoint(playerid);
		PlayerQuest[playerid] = 0;
}

public oSetPlayerCheckpoint(playerid, Float:x, Float:y, Float:z, Float:size)
{
	DisablePlayerCheckpoint(playerid);
	PlayerCP[playerid][Coord_X] = x;
	PlayerCP[playerid][Coord_Y] = y;
	PlayerCP[playerid][Coord_Z] = z;
	PlayerCPActive[playerid] = true;
	SetPlayerCheckpoint(playerid, x, y, z, 6);// size); // TODO: size bugged
}

public oDisablePlayerCheckpoint(playerid)
{
	//SetPlayerCheckpoint(playerid, 0.0, 0.0, 0.0, 8);
    DisablePlayerCheckpoint(playerid);
    PlayerCPActive[playerid] = false;
 	PlayerCP[playerid][Coord_X] = 0;
	PlayerCP[playerid][Coord_Y] = 0;
	PlayerCP[playerid][Coord_Z] = 0;
}

public oIsPlayerInCheckpoint(playerid,Float:cpx,Float:cpy,Float:cpz,dist)
{
	if (!IsPlayerConnected(playerid)) {return 0;}
	if (!PlayerCPActive[playerid]) {return 0;}
	if (!loccmp(cpx,cpy,cpz,PlayerCP[playerid][Coord_X],PlayerCP[playerid][Coord_Y],PlayerCP[playerid][Coord_Z])) return 0;
	new Float:playerx,Float:playery,Float:playerz;
	GetPlayerPos(playerid,playerx,playery,playerz);

	if (GetDistanceXYZtoXYZ(playerx,playery,playerz,cpx,cpy,cpz) < dist)
	{
	    return IsPlayerInCheckpoint(playerid);
	}
	return 0;
}

public Float:GetMaxHealth(playerid)
{
    if (!IsPlayerConnected(playerid)) {return 0.0;}
	new Float:maxhealth;
	if (Player[playerid][Level] == 0) {return 50.0;}
	maxhealth = (50.0 + (Player[playerid][Level] * 5.0));
	return maxhealth;
}

public GetXPToLevel(playerid,level)
{
	if (!IsPlayerConnected(playerid)) {return 0;}
	new xptolevel;
	xptolevel=0;
	if ((level <= MAX_LEVEL) && (level > Player[playerid][Level]))
	{
		xptolevel = gLevelList[level] - Player[playerid][XP];
 	}
    else
    {
        xptolevel = 0;
	}
	return xptolevel;
}

public CalculatePlayerLevel(playerid)
{
    if (!IsPlayerConnected(playerid)) {return 0;}
	new level;
	level = 0;
	
	for (new i = 0; i <= MAX_LEVEL; i++)
	{
		if (GetPlayerXP(playerid) >= gLevelList[i])
		{
	    	level = i;
		}
	}
 	return level;
 }

public GetPlayerLevel(playerid)
{
    if (!IsPlayerConnected(playerid)) {return 0;}
	return Player[playerid][Level];
}

public GetPlayerXP(playerid)
{
    if (!IsPlayerConnected(playerid)) {return 0;}
	return Player[playerid][XP];
}

public SetPlayerXP(playerid, xpamount)
{
    if (!IsPlayerConnected(playerid)) return;
	Player[playerid][XP] = xpamount;
	UpdatePlayerScore(playerid);
}

public GivePlayerXP(playerid, xpamount,showtext) // showtext = do we display "You gain %d XP"  to client
{
    if (!IsPlayerConnected(playerid)) return;
    if (xpamount == 0) return;
    
    if (PlayerGangid[playerid] != 0)
    { // in a gang
        if (xpamount > 100)
        {
            new gangxp = xpamount / 4;
    		new string[MAX_STRING];
			format(string, sizeof(string), "Your recieve %d gang xp.", gangxp);

			SendGangMessage(PlayerGangid[playerid],string,COLOR_XP_GOOD);
			GangGiveXP(PlayerGangid[playerid],gangxp,playerid);

		}
    }
    
    new texttime;
	if (xpamount <= 50)
	{
		texttime = 500;
	}
	else if (xpamount < 200)
	{
	    texttime = 1000;
	}
	else if (xpamount < 500)
	{
	    texttime = 1500;
	}
	else if (xpamount < 1000)
	{
	    texttime = 2000;
	}
	else if (xpamount < 2000)
	{
	    texttime = 4000;
	}
	else
	{
		texttime = 5000;
	}
    
	new string[256];
	if ((GetPlayerXP(playerid) + xpamount) < 0) // if after add xp, playerxp < 0
	{
		SetPlayerXP(playerid, 0);
		if (showtext == 1)
		{
			format(string, sizeof(string), "You loose %d XP.", xpamount);
			SendClientMessage(playerid, COLOR_XP_BAD, string);
		}
		return;
	}
	
	if ((GetPlayerXP(playerid) + xpamount) > MAX_XP) // if after add, playerxp > MAX
	{
		if (showtext == 1)
		{
			format(string, sizeof(string), "You gain %d XP.", MAX_XP - GetPlayerXP(playerid));
			SendClientMessage(playerid, COLOR_XP_GOOD, string);
			SendClientMessage(playerid, COLOR_RED, "You can gain no more XP!");
		}
		SetPlayerXP(playerid, MAX_XP);
		return;
	}
	
	SetPlayerXP(playerid, (GetPlayerXP(playerid) + xpamount));
	
	if (showtext==1)
	{
		if (xpamount >= 0)
		{
			format(string, sizeof(string), "You gain %d XP.", xpamount);
			SendClientMessage(playerid, COLOR_XP_GOOD, string);
		}
		else
		{
			format(string, sizeof(string), "You loose %d XP.", xpamount);
			SendClientMessage(playerid, COLOR_XP_BAD, string);
		}
	}
	
	if (xpamount >= 0)
	{
		format(string, sizeof(string), "+%d XP", xpamount);
		GameTextForPlayer(playerid,string,texttime,3);
	}
	else
	{
		format(string, sizeof(string), "-%d XP", xpamount);
		GameTextForPlayer(playerid,string,texttime,3);
	}
	CheckPlayerLevel(playerid);
	UpdatePlayerScore(playerid);
}

public CheckPlayerLevel(playerid)
{
    if (!IsPlayerConnected(playerid)) {return;}
	new level;
	level = CalculatePlayerLevel(playerid);
	if (Player[playerid][Level] != level)
	{
	    PlayerLevelUp(playerid,level);
	}
}

public PlayerLevelUp(playerid,level)
{
    if (!IsPlayerConnected(playerid)) {return;}
	new string[256];
    Player[playerid][Level] = level;
	GivePlayerLeveledWeapons(playerid);
	oSetPlayerHealth(playerid,GetMaxHealth(playerid));
	format(string, sizeof(string), "You are now level %d", Player[playerid][Level]);
	SendClientMessage(playerid, COLOR_XP_GOOD, string);
	new Float:playerx,Float:playery,Float:playerz;
	GetPlayerPos(playerid,playerx,playery,playerz);
	PlayerPlaySound(playerid,1057,playerx,playery,playerz);
}

public oSetPlayerMoney(playerid,money)
{
	if (!IsPlayerConnected(playerid)) return;
	SetPlayerMoney(playerid,money);
 	Player[playerid][Money] = money;
	UpdatePlayerScore(playerid);
	return;
}

public oGivePlayerMoney(playerid,money,showtext)
{
	if (!IsPlayerConnected(playerid))	return;
	if (money == 0) return;
	new string[MAX_STRING];
	SetPlayerMoney(playerid,Player[playerid][Money] + money);
	Player[playerid][Money] = (Player[playerid][Money] + money);
	if (showtext == 1)
	{
		if (money >= 0)
		{
			format(string, sizeof(string), "You recieve $%d.", money);
			SendClientMessage(playerid, COLOR_MONEY_GOOD, string);
		}
		else
		{
			format(string, sizeof(string), "You loose $%d.", money);
			SendClientMessage(playerid, COLOR_MONEY_BAD, string);
		}
	}
	UpdatePlayerScore(playerid);
}

public oGetPlayerMoney(playerid)
{
	return Player[playerid][Money];
}

public UpdatePlayerScore(playerid)
{
	SetPlayerScore(playerid,Player[playerid][Level]);
}
		
public oGetPlayerName(playerid)
{
	new name[MAX_PLAYER_NAME];
	GetPlayerName(playerid, name, sizeof (name));
	return name;
}

public Float:oGetPlayerHealth(playerid)
{
	new Float:health;
	GetPlayerHealth(playerid, health);
	return health;
}

public oSetPlayerHealth(playerid,Float:health)
{
	Player[playerid][Health] = health;
	SetPlayerHealth(playerid, health);
}


public PlayerSave(playerid)
{
	if (!IsPlayerRegistered(playerid))
	{
		#if DEBUGLEVEL > 1
			printf("player_save: FAILED: player not registered%d  %s",playerid,oGetPlayerName(playerid));
		#endif
		return 0;
	}
	
	#if DEBUGLEVEL > 0
		printf("player_save: %s",oGetPlayerName(playerid));
	#endif
	
	new filename[MAX_STRING];
	new dbstring[MAX_DBSTRING];
	filename = oGetPlayerName(playerid);
  	strcat(filename,".Status",sizeof(filename));
  	if (!udb_Exists(filename))
	{
		#if DEBUGLEVEL > 1
			printf("player_stats_save: fail: stats doesnt exists: %s",oGetPlayerName(playerid));
		#endif
		SendClientMessage(playerid,COLOR_RED, "ERROR: Player status doesnt exists.");
		return 0;
	}
	
	dbstring = CreateDBStatsString(playerid);
	udb_Savefile(filename,dbstring);
	SendClientMessage(playerid,COLOR_GREEN, "Player saved.");
	#if DEBUGLEVEL > 0
		printf("player_save: Success%s",oGetPlayerName(playerid));
	#endif
	#if OUTPUTLEVEL > 0
		printf("player_save: success %d  %s",playerid,oGetPlayerName(playerid));
	#endif

	return 1;
}


public PlayerLoadStats(playerid)
{
	if (!IsPlayerRegistered(playerid)) return 0; // login to acct first
	new filename[MAX_STRING];
	new statsdbstring[MAX_DBSTRING];
	filename = oGetPlayerName(playerid);
  	strcat(filename,".Status",sizeof(filename));

 	if (!udb_Exists(filename))
	{
		#if DEBUGLEVEL > 0
			printf("load stats : fail: %s",filename);
		#endif
		return 0;
	}
	else
	{
		statsdbstring = udb_Loadfile(filename);
	}
 	new idx;
	strtok2(statsdbstring,idx,gDBSeperator); // playername
	// set stats
	Player[playerid][Level] = strval(strtok2(statsdbstring,idx,gDBSeperator));
	Player[playerid][XP] = strval(strtok2(statsdbstring,idx,gDBSeperator));
	oSetPlayerMoney(playerid,strval(strtok2(statsdbstring,idx,gDBSeperator)));
	Player[playerid][Deaths] = strval(strtok2(statsdbstring,idx,gDBSeperator));
 	Player[playerid][Kills] = strval(strtok2(statsdbstring,idx,gDBSeperator));
   	Player[playerid][CarKills] = strval(strtok2(statsdbstring,idx,gDBSeperator));
	Player[playerid][Bank] = strval(strtok2(statsdbstring,idx,gDBSeperator));
    PlayerSpawn[playerid][Coord_X] = floatstr(strtok2(statsdbstring,idx,gDBSeperator));
    PlayerSpawn[playerid][Coord_Y] = floatstr(strtok2(statsdbstring,idx,gDBSeperator));
    PlayerSpawn[playerid][Coord_Z] = floatstr(strtok2(statsdbstring,idx,gDBSeperator));
   	new gangname[MAX_NAME];
	set(gangname,strtok2(statsdbstring,idx,gDBSeperator));
   	if (gangname[0] != 0)
   	{
   		set(PlayerGangName[playerid],gangname);
   		PlayerGangid[playerid] = GangLoad(gangname);
   		GangMemberLogin(playerid,PlayerGangid[playerid]);
   		if (PlayerGangid[playerid] == 0)
   		{
   			printf("player_gang: not found: %s",gangname);
   			new tmpname[MAX_NAME];
   			set(PlayerGangName[playerid],tmpname);
   			PlayerGangName[playerid][0] = 0;
   			PlayerGangid[playerid] = 0;
   		}
   		// TODO:
	}
	else
	{
		printf("no gang");
		PlayerGangid[playerid] = 0; // no gang
	}
	return 1;
}



public CreateDBStatsString(playerid)
{
   	new dbstring[MAX_DBSTRING];
   	new temp[MAX_STRING];

	strins(dbstring, oGetPlayerName(playerid), strlen(dbstring)); // name
	strins(dbstring, gDBSeperator, strlen(dbstring));

	valstr(temp,Player[playerid][Level]); // level
	strins(dbstring, temp, strlen(dbstring));
	strins(dbstring, gDBSeperator, strlen(dbstring));

	valstr(temp,Player[playerid][XP]); // xp
	strins(dbstring, temp, strlen(dbstring));
	strins(dbstring, gDBSeperator, strlen(dbstring));

 	valstr(temp,Player[playerid][Money]); // money
	strins(dbstring, temp, strlen(dbstring));
	strins(dbstring, gDBSeperator, strlen(dbstring));

	valstr(temp,Player[playerid][Deaths]); // deaths
	strins(dbstring, temp, strlen(dbstring));
	strins(dbstring, gDBSeperator, strlen(dbstring));

	valstr(temp,Player[playerid][Kills]); // kills
	strins(dbstring, temp, strlen(dbstring));
	strins(dbstring, gDBSeperator, strlen(dbstring));

	valstr(temp,Player[playerid][CarKills]); // carkills
	strins(dbstring, temp, strlen(dbstring));
	strins(dbstring, gDBSeperator, strlen(dbstring));

	valstr(temp,Player[playerid][Bank]); // bankmoney
	strins(dbstring, temp, strlen(dbstring));
	strins(dbstring, gDBSeperator, strlen(dbstring));
	
	new Float:playerx, Float:playery, Float:playerz;
 	GetPlayerPos(playerid,playerx,playery,playerz);
    if (playerz > 900)
    { // we must be indoors
        playerx=0;
        playery=0;
        playerz=0;
	}
 	format(temp,sizeof(temp),"%f",playerx);
	strins(dbstring, temp, strlen(dbstring));
	strins(dbstring, gDBSeperator, strlen(dbstring));
	
	format(temp,sizeof(temp),"%f",playery);
	strins(dbstring, temp, strlen(dbstring));
	strins(dbstring, gDBSeperator, strlen(dbstring));
	
	format(temp,sizeof(temp),"%f",playerz);
	strins(dbstring, temp, strlen(dbstring));
	strins(dbstring, gDBSeperator, strlen(dbstring));
	
	strins(dbstring, PlayerGangName[playerid], strlen(dbstring));
	strins(dbstring, gDBSeperator, strlen(dbstring));
	
	return dbstring;
	
}

